API_VERSION = 'API_v1.0'
MOD_NAME = "GSB10_ABYSSAL_Kurfurst_Mortarion"
SHIPS_LIST = ['GSB110_Grossdeutschland']
SETTINGS = {'installed':False, 'used':{}}
MOD_PATH = utils.getModDir()
if utils.isPathExists(MOD_PATH + '/settings.cfg'):
    with open('settings.cfg', 'rb') as f:
        SETTINGS = utils.jsonDecode( f.read() )
SHIPS_LIST = dict( [[value, True] if value not in SETTINGS['used']  else (value, SETTINGS['used'][value]) for value in SHIPS_LIST] )

def install():
    SHIPS_TO_BUILD = [
    ('GSB110_Grossdeutschland', 'content'),
    ]
    
    
    FIX_COMMON_MODELS = set(['German_Disk_3Blade_01.tga','German_Disk_3Blade_02_alpha.tga'])
    
    
    def writeFile(file, data):
        with open(file, 'wb') as f:
            f.write(data)
    
    def readFile(file):
        try:
            with open(file, 'rb') as f:
                data = f.readlines()
        except:
            return None
        return list(data)
    
    def build():
        if SHIPS_TO_BUILD:
            ship, oldMod = SHIPS_TO_BUILD.pop()
            for dirname, dirnames, filenames in utils.walk( "%s/%s"%(MOD_PATH, ship) ):
                for filename in filenames:
                    path = ('%s/%s'%(dirname, filename)).replace('\\', '/').replace('//', '/')
                    ext = filename[filename.rfind('.'):]
                    if ext == '.mfm':
                        data = readFile(path)
                        idx = -1
                        for line in data:
                            idx += 1
                            if 'content/gameplay/' in line:
                                for common_model in FIX_COMMON_MODELS:
                                    if common_model in line:
                                        toreplace = line.split('</Texture>')[0]
                                        replacestr = '<Texture>\tcontent/gameplay/common/textures/%s\t'%common_model
                                        data[idx] = line.replace(toreplace, replacestr)
                        
                        writeFile(path, ''.join(data) )
            
            contentSdk.buildMod(MOD_NAME, ship, oldMod)
            if SHIPS_TO_BUILD:
                next()
            else:
                SETTINGS['installed'] = True
                writeConfig()
                contentSdk.onDone(MOD_NAME)
    def next():
        contentSdk.extractSources(MOD_NAME, SHIPS_TO_BUILD[-1][0], callback = build)
    
    next()

def writeConfig():
    with open('settings.cfg', 'wb') as f:
        SETTINGS['used'] = SHIPS_LIST
        f.write( utils.jsonEncode( SETTINGS ) )
if not SETTINGS['installed']:
    install()
else:
    for ship, state in SHIPS_LIST.iteritems():
        if state:
            contentSdk.registerShipMod(ship)